<?php

defined('_JEXEC') or die('Restricted access');



class plgJshoppingOrderStatus_Text extends JPlugin

{

    public function __construct(&$subject, $config = array()){

        parent::__construct($subject, $config);  

    }



	public function onBeforeSendClientMailOrderStatus(&$message, &$order, &$comments, &$new_status, &$vendorinfo, &$order_details_url, &$ishtml, &$mailfrom, &$fromname, &$subject){

		$this->_changeMailMessage($message, $order, $comments, $new_status, $vendorinfo, $order_details_url, $ishtml);

	}

	

	public function onBeforeSendVendorMailOrderStatus(&$message, &$order, &$comments, &$new_status, &$vendorinfo, &$order_details_url, &$ishtml, &$mailfrom, &$fromname, &$subject, &$datavendor){

		$this->_changeMailMessage($message, $order, $comments, $new_status, $vendorinfo, $order_details_url, $ishtml);

	}

	

    private function _changeMailMessage(&$message, $order, $comments, $new_status, $vendorinfo, $order_details_url, &$ishtml){

        if (isset($new_status->email_text) && !empty($new_status->email_text)){

            $text = unserialize($new_status->email_text);

            $lang = \JSFactory::getLang();

            

            if (isset($text['text_'.$lang->lang]) && !empty($text['text_'.$lang->lang])){

                $name = $lang->get('name');

                $message = $text['text_'.$lang->lang];

                $message = str_replace('{first_name}', $order->f_name, $message);

                $message = str_replace('{last_name}', $order->l_name, $message);

                $message = str_replace('{order_number}', $order->order_number, $message);

                $message = str_replace('{order_status}', $new_status->$name, $message);

                if ($order_details_url){

                    $message = str_replace('{order_detail_url}', '<a href = "'.$order_details_url.'">'.$order_details_url.'</a>', $message);

                } else {

                    $message = str_replace('{order_detail_url}', '', $message);

                }

                $message = str_replace('{comment}', $comments, $message);

                $message = str_replace('{company}', $vendorinfo->company_name, $message);

                $message = str_replace('{address}', $vendorinfo->adress, $message);

                $message = str_replace('{zip}', $vendorinfo->zip, $message);

                $message = str_replace('{city}', $vendorinfo->city, $message);

                $message = str_replace('{country}', $vendorinfo->country, $message);

                $message = str_replace('{phone}', $vendorinfo->phone, $message);

                $message = str_replace('{fax}', $vendorinfo->fax, $message);

                

                $vartext = 'Die Möglichkeit einer Sendungsverfolgung ist bei dieser Bestellung leider nicht gegeben.';
if (isset($order->tracking_number) && $order->tracking_number) {
$vartext = 'Sendungsnummer: <a title="DHL Sendungsverfolgung" href="http://nolp.dhl.de/nextt-online-public/set_identcodes.do?lang=de&idc='.$order->tracking_number.'&rfn=&extendedSearch=true" target="_blank" rel="noopener noreferrer">'.$order->tracking_number.' </a><br /><a title="Sendung verfolgen" href="http://nolp.dhl.de/nextt-online-public/set_identcodes.do?lang=de&idc='.$order->tracking_number.'&rfn=&extendedSearch=true" target="_blank" rel="noopener noreferrer">Sendung verfolgen</a></p>  <p>Systembedingt kann es bis zu 24h dauern, bis die Daten zur Sendungsverfolgung beim Versanddienstleister DHL abgerufen werden können.';
}

$message = str_replace('{tracking_number}', $vartext, $message);



				$shipping = $order->getShipping();

				if (isset($shipping->tracking_url)) {

					$tracking_number_url = str_replace('{number}', $order->tracking_number, $shipping->tracking_url);

				} else {

					$tracking_number_url = '';

				}

				$message = str_replace('{tracking_number_url}', $tracking_number_url, $message);



                $ishtml = true;

            }

        }

    }

	

	public function onBeforeSendMailChangeOrderStatusClient(&$mailer, &$order_id, &$status, &$sendmessage, &$order){

		$send_status = $this->getStatusSendInvoice();

		if (count($send_status) && in_array($status, $send_status)) {

			$mailer->addAttachment(\JSFactory::getConfig()->pdf_orders_path."/".$order->pdf_file);

		}

		

        if (\JFactory::getApplication()->getName() == 'administrator') return;

        

		$message = '';		

		$comments = '';

		$new_status = \JSFactory::getTable('orderStatus', 'jshop');

        $new_status->load($status);

		

		$uri = \JURI::getInstance();

        $liveurlhost = $uri->toString( array("scheme",'host', 'port'));

        $order_details_url = $liveurlhost.\JSHelper::SEFLink('index.php?option=com_jshopping&controller=user&task=order&order_id='.$order_id, 1);

        if ($order->user_id==-1){

            $order_details_url = '';

        }

		$ishtml = false;

		$vendorinfo = $order->getVendorInfo();

		

		$this->_changeMailMessage($message, $order, $comments, $new_status, $vendorinfo, $order_details_url, $ishtml);

		

		$mailer->setBody($message);

        $mailer->isHTML(true);

	}

	

	public function onBeforeSendEmailsOrder(&$order, &$listVendors, &$file_generete_pdf_order, &$admin_send_order, &$obj) {

		$send_status = $this->getStatusSendInvoice();

		if (count($send_status) && !in_array($order->order_status, $send_status)) {

			$jshopConfig = \JSFactory::getConfig();

			$jshopConfig->order_send_pdf_client = 0;

		}

	}

	

	private function getStatusSendInvoice(){

		$addon = JSFactory::getTable('addon', 'jshop');

		$addon->loadAlias('status_text');

		$prms = $addon->getParams();

		return array_filter($prms['status_send_invoice'] ?? []);

	}



}